<?php
/**
* Este arquivo funciona em conjunto com a biblioteca Zend_Gdata (posicionada em C:\xampp\php\ZendGdata-1.11.10\library).  necessrio
* configurar o arquivo php.ini, adicionando a localizao da biblioteca Zend_Gdata ao parmetro "include_path". Na rea relativa a extenes 
* do arquivo php.ini, deve ser adicionada (caso no houver) a linha: extension=php_openssl.dll
* Tambm so necessrios os arquivos 'video_browser.js', 'index.php', 'video_browser.css' e 'extrai_script.js' (para executar cdigo Javascript
* retornado atravs de Ajax. Sem isso, cdigos Javascript em contedo inserido por Ajax no so executados, visto que Javascript  executado
* no carregamento da pgina - quando o Ajax  executado, a pgina j foi carregada, por isso contedos Javascript inseridos via Ajax no so executados,
* a no ser utilizando essa funo chamada extrai_script.js) .
* A chamada para a listagem dos vdeos comea no evento onload da tag body do arquivo de interface (interface.html). Nesse momento  
* executada a funo Javascript ytvbp.listVideos(autor, pgina), onde se deve passar como parmetros o autor do canal do Youtube e a 
* pgina da paginao a ser exibida primeiro, entretanto, pode-se chamar a funo ytvbp.listVideos passando apenas o autor (nesse caso, o
* parmetro "pgina"  automaticamente definido como sendo igual a 1). Por fim, o arquivo 'video_browser.js' se comunica com o arquivo 
* 'index.php', que faz uso da biblioteca  Zend_Gdata para obter listas de vdeo do Youtube. O arquivo 'index.php' devolve o resultado da busca 
* para o arquivo 'video_browser.js' e este ltimo injeta o contedo no arquivo de interface (interface.html) atravs de Ajax.  O arquivo video 
* 'video_browser.css' serve para posicionar e tratar visualmente os elementos retornados. Para tudo isso funcionar, 
*  preciso ter PHP >= 5.1.4

Este arquivo foi adaptado para funcionar no site: http://www.andrefigueiredo.net/
 */

/**
 * @see Zend_Loader
 */
require_once 'Zend/Loader.php';

/**
 * @see Zend_Gdata_YouTube
 */
Zend_Loader::loadClass('Zend_Gdata_YouTube');

/**
 * Finds the URL for the flash representation of the specified video
 *
 * @param  Zend_Gdata_YouTube_VideoEntry $entry The video entry
 * @return string|null The URL or null, if the URL is not found
 */
function findFlashUrl($entry)
{
    foreach ($entry->mediaGroup->content as $content) {
        if ($content->type === 'application/x-shockwave-flash') {
            return $content->url;
        }
    }
    return null;
}

/**
 * Echo img tags for the first thumbnail representing each video in the
 * specified video feed.  Upon clicking the thumbnails, the video should
 * be presented.
 *
 * @param  Zend_Gdata_YouTube_VideoFeed $feed The video feed
 * @return void
 */
function echoThumbnails($feed)
{
    foreach ($feed as $entry) {
        $videoId = $entry->getVideoId();
        echo '<img src="' . $entry->mediaGroup->thumbnail[0]->url . '" ';
        echo 'width="80" height="72" onclick="ytvbp.presentVideo(\'' . $videoId . '\')">';
    }
}

/**
 * Echo the video embed code, related videos and videos owned by the same user
 * as the specified videoId.
 *
 * @param  string $videoId The video
 * @return void
 */
function echoVideoPlayer($videoId)
{
    $yt = new Zend_Gdata_YouTube();

    $entry = $yt->getVideoEntry($videoId);
    $videoTitle = $entry->mediaGroup->title;
    $videoUrl = findFlashUrl($entry);

	// Ateno: na div a seguir foi inserida um enorme css inline. Apesar dessa prtica ser desaconselhvel, nesse caso  o mais 
	// adequado, pois simplesmente inserir um atributo de classe css (class='nome_da_classe'), no funciona quando ele  inserido 
	// dinamicamente atravs de Ajax	
    print <<<END
    <div style="text-align: left; font-family: Arial,Tahoma,Verdana,Helvetica,sans-serif; color: #585570; font-size: 21px; font-weight: normal; margin-top: 20px; padding-bottom: 0; width: 100%;"> ${videoTitle}</div><br />
	<div style="border: 5px solid #EFF0E8; margin-bottom: 10px; width: 481px;">\n
		<object width="481" height="384">\n
		  <param name="movie" value="${videoUrl}&feature=related"></param>\n
		  <param name="wmode" value="transparent"></param>\n
		  <embed src="${videoUrl}&feature=related" type="application/x-shockwave-flash" wmode="transparent"
			width="481" height="384"></embed>\n
		</object>\n
	</div>
END;

}

/**
 * Echo the list of videos in the specified feed.
 *
 * @param  Zend_Gdata_YouTube_VideoFeed $feed The video feed
 * @param disableNextButton Boolean, disable or not the next button (this button is in the file that receives the video list)
 * @return void
 */
function echoVideoList($feed, $disableNextButton)
{	
	if($disableNextButton === true){
		// Disable the next button (this button is in the file that receives the video list)
		echo "<script type='text/javascript'> document.getElementById('nextPageButton').disabled = true;	</script> \n";
	}else{
		// Enable the next button (this button is in the file that receives the video list)
		echo "<script type='text/javascript'> document.getElementById('nextPageButton').disabled = false; </script> \n";
	}	
	
	// Ateno: na div a seguir foi inserida um enorme css inline. Apesar dessa prtica ser desaconselhvel, nesse caso  o mais 
	// adequado, pois simplesmente inserir um atributo de classe css (class='nome_da_classe'), no funciona quando ele  inserido 
	// dinamicamente atravs de Ajax
	foreach ($feed as $entry) {	
		$videoId = $entry->getVideoId();
		$thumbnailUrl = $entry->mediaGroup->thumbnail[0]->url;
		$videoTitle = $entry->mediaGroup->title;
		
		print <<<END
		<div style="border-color: #F6F6F6; border-style: solid; border-width: 0 2px 0 0; color: #585570; float: left; height: 195px; margin-bottom: 5px; margin-right: 5px; padding-right: 10px; text-align: center; width: 135px;">
			<a href="conteudo.php?LISTA=video&VIDEOID=${videoId}">
				<img src="${thumbnailUrl}" width="120px" border="0" />
			</a><br />
			${videoTitle}  <br />\n
		</div> \n
END;
	}
	
}

/*
 * The main controller logic of the YouTube video browser app.
 */
$author = isset($_POST['author']) ? $_POST['author'] : null;

if ($author !== null) {
    /* display a list of videos */    
    $maxResults = $_POST['maxResults'];
	$startIndex = $_POST['startIndex'];    

    $yt = new Zend_Gdata_YouTube();

	$query = $yt->newVideoQuery();	
	$query->setAuthor($author);
	$feed = $yt->getVideoFeed($query); // Get the video feed initially only by author
	$feedTotalNumberOfVideos = $feed->count(); // Total number of videos (by author)
	
	$query->setStartIndex($startIndex);
	$query->setMaxResults($maxResults);
	$feed = $yt->getVideoFeed($query);
	
	/**
	* $startIndex + $maxResults = the next startIndex
	* If the next startIndex is bigger than the total number of videos of the feed ($feedTotalNumberOfVideos), 
	* it disables the next button (this button is in the file that receives the video list)
	*/
	if ( ($startIndex + $maxResults) >  $feedTotalNumberOfVideos){
		echoVideoList($feed, true);
	}else{
		echoVideoList($feed, false);
	}

}

/* display an individual video */
if (array_key_exists('videoId', $_POST)) {
	$videoId = isset($_POST['videoId']) ? $_POST['videoId'] : null;
	if($videoId !== null){	
		echoVideoPlayer($videoId);
	}
} else if (array_key_exists('videoId', $_GET)) {
	$videoId = isset($_GET['videoId']) ? $_GET['videoId'] : null;
	if($videoId !== null){	
		echoVideoPlayer($videoId);
	}
} 